void calG2(double ***AZ, int ***ZID, double ****YO, double ****Omega, double ****XIB, double ***MU, double ****LY, double ***PSX, double ****BI,
double ***PSD, double ****PHI, double ***phi, double ***ALPHA, double ***G, double ****G_stru, double ****G_miss, double ***G_tran)
{

	// data
	double *TT;
	// double TT[1+NX];

	int i, j, k, l, m, n, r, s, t, zc;
	double tmp1, tmp2, tmp3;
	
	TT=vector(1, 1+NX);

	for (k=1; k<=2; k++) {
		for (i=1; i<NO; i++) {
			for (t=1; t<NT; t++) {
				zc=ZID[k][i][t];
				
				tmp1=tmp2=0;
				r=0;
				
				for (j=1; j<NY[k]; j++) {
					tmp1=phi[k][zc][1]+phi[k][zc][2]*YO[k][i][j][t];
					
					for (l=1; l<NX; l++)
						tmp1+=phi[k][zc][2+l]*AZ[i][l][t];
					
					tmp2=exp(tmp1);
					
					tmp3=phi[k][zc][2]*YO[k][i][j][t];
					
					G[k][i][1]+=1+YO[k][i][j][t]*YO[k][i][j][t]/PSX[k][zc][j]+tmp2*tmp3*tmp3/((1+tmp2)*(1+tmp2));
					G[k][i][2]+=0.5+0.25*IYY[k][i][j][t]*tmp3+0.25*tmp2*tmp3*tmp3/((1+tmp2)*(1+tmp2))-0.25*tmp2*tmp3/(1+tmp2);
				}
				
				for (j=1; j<NM[k]; j++) {
					G_stru[k][zc][1][1]+=(PHI[k][zc][1][1]*PHI[k][zc][2][2]+2*PHI[k][zc][1][2]*PHI[k][zc][1][2])/PSD[k][zc][j];
					G_stru[k][zc][1][2]+=3*PHI[k][zc][1][1]*PHI[k][zc][1][2]/PSD[k][zc][j];
					G_stru[k][zc][1][3]+=3*PHI[k][zc][2][2]*PHI[k][zc][1][2]/PSD[k][zc][j];
					G_stru[k][zc][2][2]+=3*PHI[k][zc][1][1]*PHI[k][zc][1][1]/PSD[k][zc][j];
					G_stru[k][zc][2][3]+=(PHI[k][zc][1][1]*PHI[k][zc][2][2]+2*PHI[k][zc][1][2]*PHI[k][zc][1][2])/PSD[k][zc][j];
					G_stru[k][zc][3][3]+=3*PHI[k][zc][2][2]*PHI[k][zc][2][2]/PSD[k][zc][j];
				}
				
				tmp1=exp(phi[k][zc][1]);
				
				for (j=1; j<NY[k]; j++) {
					TT[1]=YO[k][i][j][t];
				
					for (l=1; l<NX; l++)
						TT[1+l]=AZ[i][l][t];

					for (m=1; m<1+NX; m++)
						for (n=1; n<=m; n++)
							G_miss[k][zc][m][n]+=TT[m]*TT[n]*tmp1/((1+tmp1)*(1+tmp1));
				}
			}
			
			for (t=2; t<NT; t++) {
				zc=ZID[k][i][t];
				
				for (j=1; j<zc; j++)
					tmp1+=exp(ALPHA[k][zc][j])/((1+exp(ALPHA[k][zc][j]))*(1+exp(ALPHA[k][zc][j])));
				
				if (zc<NC[k]-1)
					tmp1+=exp(ALPHA[k][zc][zc])/((1+exp(ALPHA[k][zc][zc]))*(1+exp(ALPHA[k][zc][zc])));
				
				for (m=1; m<NX; m++)
					for (n=1; n<=m; n++)
						G_tran[k][m][n]+=AZ[i][m][t]*AZ[i][n][t]*tmp1;
			}
		}
	}

	free_vector(TT, 1, 1+NX);

	return ;
}
