#include "fac.c"

void genomega(int ***ZID, double ****BI, double ***PSD, double ****PHI, double ****TUE)
{
	int i, j, k, l, t, zc;
	long random;
	double ****XI, ****XIB;
	// double XI[2][NO][NZ2][NT], XIB[2][NO][NB2][NT];
	
	XI=array4(1, 2, 1, NO, 1, NZ2, 1, NT);
	XIB=array4(1, 2, 1, NO, 1, NB2, 1, NT);
	
	fac(ZID, PHI, XI);

	for (k=1; k<=1; k++)
		for (i=1; i<NO; i++)
			for (t=1; t<NT; t++) {
				zc=ZID[k][i][t];
				
				for (j=1; j<NZ[k]; j++)
					TUE[k][i][j+NM[k]-1][t]=XI[k][i][j][t];
				
				for (j=1; j<NZ[k]; j++)
					XIB[k][i][j][t]=XI[k][i][j][t];
				
				XIB[k][i][3][t]=XI[k][i][1][t]*XI[k][i][2][t];
				XIB[k][i][4][t]=XI[k][i][1][t]*XI[k][i][1][t];
				XIB[k][i][5][t]=XI[k][i][2][t]*XI[k][i][2][t];
				// nonlinear structural equation
				
				for (j=1; j<NM[k]; j++) {
					random=rand();
					TUE[k][i][j][t]=gasdev(&random)*sqrt(PSD[k][zc][j]);
					
					for (l=1; l<NB[k]; l++)
						TUE[k][i][j][t]+=BI[k][zc][j][l]*XIB[k][i][l][t];					

				}
			}

	free_array4(XI, 1, 2, 1, NO, 1, NZ2, 1, NT);
	free_array4(XIB, 1, 2, 1, NO, 1, NB2, 1, NT);

	return ;
}
