void newbi2(double **NEYO, double ***X, int **ZID, double *Beta, double *psi, double *PBeta,
int alpha, int beta, double sig, int NB, int zc)
{
	int i, j, k, t, m, n, num;
	long random;
	double AK, *PP, *XX, **imaf;

	PP=vector(1, NB2); 
	XX=vector(1, NB2); 
	imaf=matrix(1, NB2, 1, NB2);

	for (i=1; i<NB; i++) {
		PP[i]=sig*PBeta[i];
		
		imaf[i][i]=sig;
		
		for (j=1; j<i; j++)
			imaf[j][i]=imaf[i][j]=0;
	}
	
	num=0;
	
	AK=beta;
	
	for (i=1; i<NO; i++)
		for (t=1; t<NT; t++)
			if (ZID[i][t]==zc) {
				for (j=1; j<NB; j++) {
					PP[j]+=NEYO[i][t]*X[i][j][t];
					for (k=1; k<NB; k++)
						imaf[j][k]+=X[i][j][t]*X[i][k][t];
				}

				AK+=0.5*NEYO[i][t]*NEYO[i][t];
				
				num++;
			}

	iv(imaf, NB);

	for (i=1; i<NB; i++)
		AK+=0.5*PBeta[i]*PBeta[i]*sig;


	for (i=1; i<NB; i++) {
		XX[i]=0.0;
		for (j=1; j<NB; j++)
			XX[i]+=imaf[i][j]*PP[j];
		AK-=0.5*PP[i]*XX[i];
	}

	m=num/2+alpha;
	
	(*psi)=AK/gamdev(m, &random);

	choldc(imaf, NB-1, PP);

	for (i=1; i<NB; i++) {
		imaf[i][i]=PP[i];
		random=rand();
		PP[i]=gasdev(&random);
	}
	
	for (i=1; i<NB; i++)
		for (j=1; j<=i; j++)
			XX[i]+=sqrt(*psi)*imaf[i][j]*PP[j];

	for (i=1; i<NB; i++)
		Beta[i]=XX[i];

	free_vector(PP, 1, NB2); 
	free_vector(XX, 1, NB2); 
	free_matrix(imaf, 1, NB2, 1, NB2);

	return ;
}
