void newid(int ***ZID, double ****f, double *****PROP)
{
	int i, k, t, u1, u2, s, w;
	long random;
	double unfm, **Q_forward, **Q_back, *Q;
	
	Q_forward=matrix(1, NT, 1, NC2);
	Q_back=matrix(1, NT, 1, NC2);
	Q=vector(1, NC2);
	
	for (k=1; k<=2; k++)
		for (i=1; i<NO; i++) {
			for (u1=1; u1<NC[1]; u1++) {
				Q_forward[1][u1]=f[k][u1][i][1]*PROP[k][i][1][u1][0];

				Q_back[NT-1][u1]=1;
			}

			for (t=2; t<NT; t++)
				for (u1=1; u1<NC[1]; u1++)  {
					Q_forward[t][u1]=0;

					for (s=1; s<NC[1]; s++)
						Q_forward[t][u1]+=Q_forward[t-1][s]*f[k][u1][i][t]*PROP[k][i][t][u1][s];
				}

			for (t=NT-2; t>=1; t--)
				for (u1=1; u1<NC[1]; u1++) {
					Q_back[t][u1]=0;
						
					for (s=1; s<NC[1]; s++)
						Q_back[t][u1]+=Q_back[t+1][s]*f[k][s][i][t+1]*PROP[k][i][t+1][s][u1];
				}
			
			for (t=1; t<NT; t++) {
				unfm=0;
				
				for (u1=1; u1<NC[1]; u1++) {
					Q[u1]=Q_back[t][u1]*Q_forward[t][u1];
					unfm+=Q[u1];
				}
				
				if (unfm<1e-8) {
					for (u1=1; u1<NC[1]; u1++)
						Q[u1]=1.0/(NC[1]-1);
				}
				else
					for (u1=1; u1<NC[1]; u1++)
						Q[u1]/=unfm;

				for (u1=2; u1<NC[1]; u1++)
					Q[u1]+=Q[u1-1];
			
				random=rand();
				unfm=ran2(&random);
				
				for (u1=1; u1<NC[1] && unfm>Q[u1]; u1++)
					;

				ZID[k][i][t]=u1;
			}
		}
	
	free_matrix(Q_forward, 1, NT, 1, NC2);
	free_matrix(Q_back, 1, NT, 1, NC2);
	free_vector(Q, 1, NC2);

	return ;
}
