void newly(double **NEYO, double ***X, int **ZID, double *Beta, double *psi, double *PBeta,
int alpha, int beta, double sig, int Row_n, int *CLY, int zc)
{
	int i, j, k, t, m, n, num;
	long random;
	double AK, *PP, *XX, **imaf;

	PP=vector(1, NK2); 
	XX=vector(1, NK2); 
	imaf=matrix(1, NK2, 1, NK2);

	for (i=1; i<=Row_n; i++) {
		n=CLY[i];
		PP[i]=sig*PBeta[n];
		
		imaf[i][i]=sig;
		
		for (j=1; j<i; j++)
			imaf[j][i]=imaf[i][j]=0;
	}	
	
	num=0;
	
	AK=beta;
	
	for (i=1; i<NO; i++)
		for (t=1; t<NT; t++)
			if (ZID[i][t]==zc) {
				for (j=1; j<=Row_n; j++) {
					m=CLY[j];
					PP[j]+=NEYO[i][t]*X[i][m][t];
					for (k=1; k<=Row_n; k++) {
						n=CLY[k];
						imaf[j][k]+=X[i][m][t]*X[i][n][t];
					}
				}

				AK+=0.5*NEYO[i][t]*NEYO[i][t];
				
				num++;
			}

	iv(imaf, Row_n+1);

	for (i=1; i<=Row_n; i++) {
		m=CLY[i];
		AK+=0.5*PBeta[m]*PBeta[m]*sig;
	}

	for (i=1; i<=Row_n; i++) {
		XX[i]=0.0;
		for (j=1; j<=Row_n; j++)
			XX[i]+=imaf[i][j]*PP[j];
		AK-=0.5*PP[i]*XX[i];
	}

	m=num/2+alpha;
	
	(*psi)=AK/gamdev(m, &random);

	choldc(imaf, Row_n, PP);

	for (i=1; i<=Row_n; i++) {
		imaf[i][i]=PP[i];
		random=rand();
		PP[i]=gasdev(&random);
	}
	
	for (i=1; i<=Row_n; i++)
		for (j=1; j<=i; j++)
			XX[i]+=sqrt(*psi)*imaf[i][j]*PP[j];

	for (i=1; i<=Row_n; i++) {
		m=CLY[i];
		Beta[m]=XX[i];
	}

	free_vector(PP, 1, NK2); 
	free_vector(XX, 1, NK2); 
	free_matrix(imaf, 1, NK2, 1, NK2);

	return ;
}
