#include "tphi3.c"

int newphi3(int k, int zc, double *phi, int **ZID, double VAR)
{
	int i, t;
	long random;
	double imaf, PP, rat1, rat2, ratio;

	imaf=sigphi;
	
	for (i=1; i<NO; i++)
		for (t=1; t<NT; t++)
			if (ZID[i][t]==zc)
				imaf+=0.25*(NY[k]-1);
			
	imaf/=VAR;

	random=rand();
	PP=*phi+gasdev(&random)/sqrt(imaf);

	rat1=tphi3(k, zc, *phi, ZID);
	rat2=tphi3(k, zc, PP,  ZID);
	
	ratio=exp(rat1-rat2);
	
	random=rand();
	imaf=ran2(&random);
	
	if (imaf<=ratio) {
		*phi=PP;
		i=1;
	}
	else
		i=0;
	
	return i;
}
